#include <iostream>
#include <string> 
#include <vector>


using namespace std;



int main()
{
    int h,n;
    cin >> h >> n;
    vector<int> a(n);
    for(int i=0;i<n;i++) a[i]=1;
    for(int i=0;i<h;i++)
    {
        int pocetakStena=-1, zarobljeniProtok=0;
        bool naPocetku=true;
        int b,c=-1;
        /*for(int j=0;j<n;j++) cout << a[j] << " ";
        cout << endl;*/
        for(int j=0;j<n;j++)
        {
            cin >> b;
            if(b==0)
            {
                zarobljeniProtok+=a[j];
                a[j]=0;
                if(c==1) pocetakStena=j;
            }
            if(b==1 && c==0)
            {
                if(pocetakStena==-1) a[j]+=zarobljeniProtok;
                else
                {
                    a[pocetakStena-1]+=(zarobljeniProtok+1-i%2)/2;
                    a[j]+=zarobljeniProtok-(zarobljeniProtok+1-i%2)/2;
                }
                zarobljeniProtok=0;
            }
            if(j==n-1 && b==0) a[pocetakStena-1]+=zarobljeniProtok;
            c=b;
        }
    }
    for(int i=0;i<n;i++) cout << a[i] << " ";
    return 0;
}